'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var React = require('react');
var PropTypes = require('prop-types');
var isEmpty = require('lodash.isempty');

var _require = require('hadron-react-components'),
    FormInput = _require.FormInput;

var Actions = require('../actions');

/**
 * The kerberos auth role component.
 */

var X509 = function (_React$Component) {
  _inherits(X509, _React$Component);

  function X509() {
    _classCallCheck(this, X509);

    return _possibleConstructorReturn(this, (X509.__proto__ || Object.getPrototypeOf(X509)).apply(this, arguments));
  }

  _createClass(X509, [{
    key: 'onUsernameChanged',


    /**
     * Handle the username change.
     *
     * @param {Event} evt - The event.
     */
    value: function onUsernameChanged(evt) {
      Actions.onX509UsernameChanged(evt.target.value);
    }

    /**
     * Get the error for the required username field.
     *
     * @returns {String} The error message.
     */

  }, {
    key: 'getUsernameError',
    value: function getUsernameError() {
      var connection = this.props.currentConnection;
      if (!this.props.isValid && isEmpty(connection.x509_username)) {
        return 'Username is required';
      }
    }

    /**
     * Render the kerberos component.
     *
     * @returns {React.Component} The component.
     */

  }, {
    key: 'render',
    value: function render() {
      return React.createElement(
        'div',
        { id: 'x509-authentication', className: 'form-group' },
        React.createElement(FormInput, {
          label: 'Username',
          name: 'x509-username',
          error: this.getUsernameError(),
          changeHandler: this.onUsernameChanged.bind(this),
          value: this.props.currentConnection.x509_username || '' })
      );
    }
  }]);

  return X509;
}(React.Component);

X509.propTypes = {
  currentConnection: PropTypes.object.isRequired,
  isValid: PropTypes.bool
};

X509.displayName = 'X509';

module.exports = X509;